

// 1. Spalte Zeitachse berechnet aus Eingabe in Sekunden * Zeitfaktor, der auf der SM Karte eingetragen wurde

// Programm 1: 2x SPI mit Temperatur MAX 6630 + 4x ADW + Batteriespannung + mV Temperaturdiode
// Programm 2: 2x ADW
// Programm 3: 4x ADW oder 4 andere Messwerte  ohne Berechnungen
// Programm 4: 1x ADW
// Programm 5: 1x ADW, 1 x Batteriespannung
// Programm 6: 1x ADW ADS8345
// Programm 7: GPS
// Programm 8: 4x ADW fr Temperaturmessung Projekt 33-3
// Programm 9: 4x ADW auf SD-Karte
// Programm 10: 2x SPI mit Temperatur MAX 6630 + 4x Temperatur mit Proj33-1 + Akkuspannung + mV Temperaturdiode
// Programm 11: 2x SPI mit Temperatur MAX 6630 + 2 ADW Messstelle 1 und 2   in Arbeit
// Programm 12: EKG mobil auf SD-Karte
// Programm 13: 1x Akkuspannung + 3x I2C TMP275
// Programm 14: 4x 16 Bit Wert
// Programm 15: 1x 1 Byte  + TSic 506
// Programm 16: Akkuspannung, DS18B20, TSic 506
// Programm 17: 4x 16 Bitwerte (EKG6) SD-Karte

// Programm 20: 4x 16 Bitwerte (TS_14gc) SD-Karte  2xTSiC506
// Programm 21: 4x 16 Bit Werte (TS15gc) SD-Karte; 2xTSiC506; 1xDS18B20

//
//               Uhr und Datum
//                 MSP430F1611
//              -----------------
//              |              XIN|- 32,768kHz
//              |                 |
//  Taster rot--|RST (58)     XOUT|- 32,768kHz
//                            P5.5|LED rot
//              |             P5.6|LED Grn
// 8  Mhz X2IN- |             P2.1|Taster fr lschen
//              |             P2.0|Taster fr Start
// 8 MHz X2OUT- |       P1.0..P1.7|Daten FKA usw.
//              |                 |
//              |             P3.0|                               (28)
//       UTXD0  |P3.4         P3.1|-> Daten Ausgang               (29)
//       URXD0  |P3.5         P3.2|<- Data In  (SOMI0)            (30)
//       UTXD1  |P3.6         P3.3|-> Serial Clock Out (UCLK)     (31)
//       URXD1  |P3.7
//
//              |        P4.0-P4.7| Daten SM karte     (36)..(43)
//(44)SD-CS     |P5.0         P2.7| SD Karte Einsteckkontrolle  
//    SD-DI     |P5.1         P2.6| INT DS32C35
//    SD-DO     |P5.2         P2.5| frei
//    SD-CLK    |P5.3         P2.4| RST  DS32C35
//              |             P2.3| Temp 2 EIN/AUS
//              |             P2.2| Temp 1 EIN/AUS
//(48)  frei    |P5.4         P6.7| Spannungeingang EKG
//     LED grn |P5.6         P6.6| Steuerung FKA RD   ---------  |RD\(6)     
//     LED rot  |P5.7         P6.5| Steuerung FKA Ao   ---------  |A0(4)    |
//                            P6.4| Steuerung FKA WR   ---------  |WR\(5)   |
//                                                      Masse --- |CS(15)   |
//                                                        +5V --- |RES(16)  |
//                                                                       (3)| Kontrast ca. +1,8V gegen Masse
//                                                                       (1)| Masse
//                                                                             
//                                                               FKA W320/240
//
//
//   Wolfgang Grbel

//  Halle -- Juli 2008--
#include "TS_LC7981.h"
unsigned char sekundehex,minutehex,stundehex,taghex,monathex,jahrhex; 
unsigned char  Byte_lesen, min,sek,stunde,wert3,wert4; 
unsigned char Adresse_DS32C35 = 0x68,sekEiner,minEiner,stundeEiner,TagEiner,MonatEiner,JahrEiner,Tag,Monat,Jahr; // // Adresse DS32C35=110 1000 -->0x68
void I2C_Init (void);
void pause_x(void);
void pause(void);
void pause2(void);
void uhrzeit_lesen (void);
void Datum_lesen (void);




void pause_x(void)
{
unsigned int i;
for (i=700;i>0;i--);                 // alt i=300 warten  ca.5ms 600auf 700 erhht
}   
void I2C_Init (void) 
{
  P3SEL |= 0x0a;          // Assign I2C pins to module
  U0CTL &= ~I2CEN;        // Recommended init procedure ---schaltet I2C aus
  U0CTL |= I2C + SYNC;   // -- schaltet UART auf I2C bzw. auch SPI
         
  I2CTCTL |= I2CSSEL1;                      // SMCLK---- I2CTCTL = bertragungsregister mit SMCLK laden I2CWORD=0 --> byteweise
  I2CSA  =  Adresse_DS32C35;        // 110 1000 -->0x68
  U0CTL |= I2CEN; 
}

void uhrzeit_lesen (void)
{
  I2CNDAT = 0x01;
  U0CTL |= MST;                             // Master mode
  I2CTCTL |= I2CSTT+I2CSTP+I2CTRX;          // Initiate transfer +I2CSTP
  while ((I2CIFG & TXRDYIFG) == 0);         // Wait for transmitter to be ready
  I2CDRB = 0x00;                            // Register Sekunden
  while ((I2CTCTL & I2CSTP) == 0x02); 
 
  I2CTCTL &= ~I2CTRX;                       // Umschalten auf Empfnger  
  I2CNDAT = 0x01;   
  U0CTL |= MST;                             // Master
  I2CTCTL |= I2CSTT + I2CSTP;               // Read, ST, SP (clears MST)
  while ((I2CTCTL & I2CSTP)==  I2CSTP);     // Auf Stop warten
  sekundehex = I2CDRB;
  sekEiner =  sekundehex&0x0F;                         // 
  sek = ((( sekundehex&0x70)*10)>>4)+sekEiner;
 
  I2CNDAT = 0x01;
  U0CTL |= MST;                             // Master mode
  I2CTCTL |= I2CSTT+I2CSTP+I2CTRX;          // Initiate transfer +I2CSTP
  while ((I2CIFG & TXRDYIFG) == 0);         // Wait for transmitter to be ready
  I2CDRB = 0x01;                            // Register Minuten
  while ((I2CTCTL & I2CSTP) == 0x02); 
  I2CTCTL &= ~I2CTRX;                       // Umschalten auf Empfnger  
  I2CNDAT = 0x01;                         
  U0CTL |= MST;                             // Master
  I2CTCTL |= I2CSTT + I2CSTP;               // Read, ST, SP (clears MST)
  while ((I2CTCTL & I2CSTP)==  I2CSTP);     // Auf Stop warten
  
  minutehex= I2CDRB;
  minEiner =minutehex&0x0F;                         // 
  min = (((minutehex&0x70)*10)>>4)+minEiner;
  
  I2CNDAT = 0x01;
  U0CTL |= MST;                             // Master mode
  I2CTCTL |= I2CSTT+I2CSTP+I2CTRX;          // Initiate transfer +I2CSTP
  while ((I2CIFG & TXRDYIFG) == 0);         // Wait for transmitter to be ready
  I2CDRB = 0x02;                            // Register Stunden
  while ((I2CTCTL & I2CSTP) == 0x02); 
  I2CTCTL &= ~I2CTRX;                       // Umschalten auf Empfnger  
  I2CNDAT = 0x01;                           
  U0CTL |= MST;                             // Master
  I2CTCTL |= I2CSTT + I2CSTP;               // Read, ST, SP (clears MST)
  while ((I2CTCTL & I2CSTP)==  I2CSTP);     // Auf Stop warten
  stundehex= I2CDRB;
  stundeEiner = stundehex&0x0F;                         // 
  stunde = (((stundehex&0x70)*10)>>4)+stundeEiner;
}

void Datum_lesen (void)
{
  I2CNDAT = 0x01;
  U0CTL |= MST;                             // Master mode
  I2CTCTL |= I2CSTT+I2CSTP+I2CTRX;          // Initiate transfer +I2CSTP
  while ((I2CIFG & TXRDYIFG) == 0);         // Wait for transmitter to be ready
  I2CDRB = 0x04;                            // Register Tag
  while ((I2CTCTL & I2CSTP) == 0x02); 
 
  I2CTCTL &= ~I2CTRX;                       // Umschalten auf Empfnger  
  I2CNDAT = 0x01;   
  U0CTL |= MST;                             // Master
  I2CTCTL |= I2CSTT + I2CSTP;               // Read, ST, SP (clears MST)
  while ((I2CTCTL & I2CSTP)==  I2CSTP);     // Auf Stop warten
  taghex= I2CDRB;
  TagEiner = taghex&0x0F;                         // 
  Tag = (((taghex&0x70)*10)>>4)+TagEiner;
 
  I2CNDAT = 0x01;
  U0CTL |= MST;                             // Master mode
  I2CTCTL |= I2CSTT+I2CSTP+I2CTRX;          // Initiate transfer +I2CSTP
  while ((I2CIFG & TXRDYIFG) == 0);         // Wait for transmitter to be ready
  I2CDRB = 0x05;                            // Register Monat
  while ((I2CTCTL & I2CSTP) == 0x02); 
  I2CTCTL &= ~I2CTRX;                       // Umschalten auf Empfnger  
  I2CNDAT = 0x01;                         
  U0CTL |= MST;                             // Master
  I2CTCTL |= I2CSTT + I2CSTP;               // Read, ST, SP (clears MST)
  while ((I2CTCTL & I2CSTP)==  I2CSTP);     // Auf Stop warten
  monathex= I2CDRB;
  MonatEiner = monathex&0x0F;                         // 
  Monat = (((monathex&0x70)*10)>>4)+MonatEiner;
  
  I2CNDAT = 0x01;
  U0CTL |= MST;                             // Master mode
  I2CTCTL |= I2CSTT+I2CSTP+I2CTRX;          // Initiate transfer +I2CSTP
  while ((I2CIFG & TXRDYIFG) == 0);         // Wait for transmitter to be ready
  I2CDRB = 0x06;                            // Register Jahr
  while ((I2CTCTL & I2CSTP) == 0x02); 
 
  I2CTCTL &= ~I2CTRX;                       // Umschalten auf Empfnger  
  I2CNDAT = 0x01;   
  U0CTL |= MST;                             // Master
  I2CTCTL |= I2CSTT + I2CSTP;               // Read, ST, SP (clears MST)
  while ((I2CTCTL & I2CSTP)==  I2CSTP);     // Auf Stop warten
  jahrhex= I2CDRB;
  JahrEiner = jahrhex&0x0F;                         // 
  Jahr = (((jahrhex&0x70)*10)>>4)+JahrEiner;
} 

void datum(void)
{
	Datum_lesen ();
	lcd_write_command(LCD_CMD_CURSOR_LA,26);    //26 Zeilenanfang 2.Zeile --> 26 Zeichen pro Zeile
	lcd_write_command(LCD_CMD_CURSOR_HA,0);
		
	  char txt1[2],z,c;
    sprintf(txt1,"%02u",Tag);
    for (z=0; z<2;z++)
    {
    c=txt1[z];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);   
  }
  lcd_write_command(LCD_CMD_WRITE_DATA, ':'); 
  char txt2[2];
    sprintf(txt2,"%02u",Monat);
    for (z=0; z<2;z++)
    {
    c=txt2[z];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);   
  }
  lcd_write_command(LCD_CMD_WRITE_DATA, ':'); 
  char txt3[2];
    sprintf(txt3,"%02u",Jahr);
    for (z=0; z<2;z++)
    {
    c=txt3[z];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);  	
  
  
}
}
void uhrzeit(void)
{
	uhrzeit_lesen ();	
  lcd_write_command(LCD_CMD_CURSOR_LA,40);
	lcd_write_command(LCD_CMD_CURSOR_HA, 0);
	lcd_write_command(LCD_CMD_WRITE_DATA, 'W');
	lcd_write_command(LCD_CMD_WRITE_DATA, ' ');  
	  char txt1[2],z,c;
    sprintf(txt1,"%02u",stunde);
    for (z=0; z<2;z++)
    {
    c=txt1[z];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);   
	  }
  lcd_write_command(LCD_CMD_WRITE_DATA, ':'); 
  char txt2[2];
    sprintf(txt2,"%02u",min);
    for (z=0; z<2;z++)
    {
    c=txt2[z];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);   
  }
   lcd_write_command(LCD_CMD_WRITE_DATA, ':'); 
  char txt3[2];
    sprintf(txt3,"%02u",sek);
    for (z=0; z<2;z++)
    {
    c=txt3[z];
    lcd_write_command(LCD_CMD_WRITE_DATA, c);   
  }	
 }
