// 2x Temperatur mit TSiC506 + Uhr DS32C35 + SD-Karte + Anzeige auf FKA
 
 
// Programmarten:
// Programm 1:  2x SPI mit Temperatur MAX 6630 + 4x ADW + Batteriespannung + mV Temperaturdiode
// Programm 2:  2x ADW
// Programm 3:  4x ADW oder 4x 16 Bit Werte
// Programm 4:  1x ADW
// Programm 5:  1x ADW, 1xBatteriespannung
// Programm 6:  1x ADW 8345  16 Bit
// Programm 7:  GPS auf SM-Karte
// Programm 8:  4x ADW fr Temperaturmessung mit LM324 Projekt: 33-3
// Programm 9:  4x ADW auf SD-Karte
// Programm 10: 2x SPI mit Temperatur MAX 6630 + 4x Temperatur mit Proj33-1 + Akkuspannung + mV Temperaturdiode
// Programm 11: 2x SPI mit Temperatur MAX 6630 + 2 ADW  
// Programm 12: SD Karte lesen (EKG) SD-Karte
// Programm 13: 1x Akkuspannung + 3x I2C TMP275
// Programm 14: 4x 16 Bit Werte
// Programm 15: 1x ADW 1 1x TSic 506
// Programm 16: 1x Akkuspannung,1xDS18B20,1x TSic 506
// Programm 17: 4x 16 Bit Werte (EKG6) SD-Karte

// Programm 20: 2x 16 Bit Werte (TS14gc) SD-Karte; 2xTSiC506
// Programm 21: 4x 16 Bit Werte (TS15gc) SD-Karte; 2xTSiC506; 1xDS18B20
// Programm 22: 4x 16 Bit Werte (TS15gc) SD-Karte; 2xTSiC506; 2xDS18B20

//                 MSP430F1611
//              -----------------
//              |              XIN|- 32,768kHz
//              |                 |
//  Taster rot--|RST (58)     XOUT|- 32,768kHz
// 8  Mhz X2IN- |             
//              |             
// 8 MHz X2OUT- |       P1.0..P1.7|Daten FKA usw.
//              |                 |
//              |             P3.0|   CS1 SPI  frei               (28)
//       UTXD0  |P3.4         P3.1|-> Daten Ausgang     I2C DS32C35       (29)
//       URXD0  |P3.5         P3.2|<- Data In  (SOMI0)  I2C DS32C35       (30)
//       UTXD1  |P3.6         P3.3|-> (UCLK)            I2C DS32C35       (31)
//       URXD1  |P3.7
//
//              |        P4.0-P4.7| Daten SM karte     (36)..(43)
//(44)SD-CS     |P5.0         P2.7| SD Karte Einsteckkontrolle  
//    SD-DI     |P5.1         P2.6| Dateneingang 2  TSiC506
//    SD-DO     |P5.2         P2.5| CS2 SPI frei
//    SD-CLK    |P5.3         P2.4| Dateneingang 1  TSiC506
//              |             P2.3| Temp 2 EIN/AUS  TSiC506
//              |             P2.2| Temp 1 EIN/AUS  TSiC506
//                            P2.1| Taster fr frei
//              |             P2.0| Taster fr Start
//(48)  frei    |P5.4         P6.7| Spannungeingang
//              |P5.5         P6.6| Steuerung FKA EX
//      LED Grn|P5.6
//      LED rot |P5.7         P6.5| Steuerung FKA I/OC2
//                            P6.4| Steuerung FKA I/OC1
//
//
//   Wolfgang Grbel

// Halle  september 2009
/******************************************************************/
#include <MSP430x16x.h>      // fr MSP430F1611
#include <signal.h> 
#include "TS_P25_SD_MAINTI.c"
#include "TS_DS32C35_LC7981.h"
#include <string.h>            // fr Zeichen (Infotext) notwendig
#include <stdio.h>             // fr sprintf


void Start(void);
unsigned int  MWroh,XW,Puls_A,P1,Loe,t,sector=627,sektor=520;
unsigned char c,MWalt,PZ,P0,ZP,Pu,PZMW2,a,z=0,d3[512],d2[512],d1[512],ZeitOB=0x7F,ZeitUB=0xFF,Zeitfaktor;
void LED(void);
void Init(void);
void sektortext_ausgeben(void);
void programmversion(void);

//void grunddaten(void);
//void sprungsektorweite(void); //auch mit WINHEX einzutragen mglich
//void Datenanfang(void);
//void Fehlermeldung_ausgeben(void);

int main(void)
   {
     WDTCTL = WDTPW + WDTHOLD;   // Stop watchdog timer
			
      P2IE  = 0x83;              // an  P2.0 ,P2.1 und (2.7) Interruptfreigabe
      P2IES = 0x83;		           // auf H/L Flanke  an P2.0,P2.1 und (P2.7) festlegen
      P5DIR = BIT7 + BIT6;              // LED 
      P5OUT = BIT7 + BIT6;
    	programmversion();
        Start();
      //_BIS_SR(LPM3_bits + GIE);//
     for(;;);
      }
void Init(void)

	 {
   TACTL = TASSEL0+TACLR;//+ID_1;   // TASSEL0 = Takteingang fr ACLK(32,7kHz)--lscht Timer ID_2 Vorteiler durch 4
   TACTL |= MC0; 	         				  //  Timer zhlt bis CCRO
   TACCTL0 = CCIE;	       				  // Interruptfreigabe fr ???
   TACCR0 =(ZeitOB << 8)|ZeitUB;;		// 328 fr 10ms   164 fr 5ms    196 fr 6ms
  // Zeitfaktor=1;
   }
 void Pause1(void)
 {
 unsigned int b;
 for(b=0;b<60000;b++);
 }


// Timer A0 interrupt service routine
//#pragma vector=TIMERA0_VECTOR
//__interrupt void Timer_A (void)

interrupt (TIMERA0_VECTOR) Timer_A(void)

{
   //  P5OUT ^= BIT7;
  //   Ausgabe_Sektorrest();
     P5OUT ^= BIT6;
    }
    
  void LED(void)
{
  P5OUT &=~BIT7;
  Pause1();
  P5OUT |= BIT7;
  
}
void programmversion(void)
  {
  
   char vers[24],z,c;
    sprintf(vers,"%s","Prog.:  TS_P25_EKG_SDlesen");
    for (z=0; z<24;z++)
   {
   c=vers[z];
   lcd_write_command(LCD_CMD_WRITE_DATA, c);   
   }
  }
void Start(void)
		{
			
      Init();             	// Initialization
      text_init();
      SD_Beginn();
      _EINT();
      }
void sektortext_ausgeben(void)
  {
    char z;
     lcd_write_command(LCD_CMD_CURSOR_LA,0);    //26 Zeilenanfang 2.Zeile --> 26 Zeichen pro Zeile
     lcd_write_command(LCD_CMD_CURSOR_HA,0);
   for (z=0; z<30;z++)
   {
    c = mmc_buffer[z];
   lcd_write_command(LCD_CMD_WRITE_DATA, c); 
   P5OUT ^= BIT6;
   }
  }
//#pragma vector=PORT2_VECTOR
//__interrupt void Taste (void)

interrupt (PORT2_VECTOR)Taste (void)
	{
	if ((P2IFG&BIT0) == BIT0)
	{    
      P5OUT ^= BIT7;
	    mmcReadSector(sector,mmc_buffer); 
      sektortext_ausgeben();
	   	P2IFG&=~BIT0;
	}
	
  if ((P2IFG&BIT7) == BIT7)  // Karte wieder eingesteckt
   {
   	 LED();   
   //  SD_Beginn();
     P2IFG&=~BIT7;
   
   }
 	}


